## fltk1.4 1.4.3

=== CMakeLists.txt ===
#
# Main CMakeLists.txt to build the FLTK project using CMake (www.cmake.org)
# Originally written by Michael Surette
#
# Copyright 1998-2025 by Bill Spitzak and others.
#
# This library is free software. Distribution and use rights are outlined in
# the file "COPYING" which should have been included with this file.  If this
# file is missing or damaged, see the license at:
#
#     https://www.fltk.org/COPYING.php
#
# Please see the following page on how to report bugs and issues:
#
#     https://www.fltk.org/bugs.php
#

#######################################################################
# Set CMake minimum version first: must be set before `project()`
#######################################################################

# Minimum CMake version required by FLTK 1.4

# Note 1: Linking against OBJECT libraries (fluid, test) requires
#         at least CMake 3.12.0
# Note 2: Used in fluid since 05/2023,
#         used for Windows (MSVC) shared lib builds much earlier
# Note 3: More modern CMake features require 3.13...3.15 (Nov 2023)

cmake_minimum_required(VERSION 3.15.0 FATAL_ERROR)

# Since CMake 3.4: enable symbol export from all executable targets
# cmake_policy(SET CMP0065 OLD)

#######################################################################
# define the FLTK project and version
#######################################################################

project(FLTK VERSION 1.4.3)

#######################################################################
# include macro and function definitions for general usage
#######################################################################

include(CMake/fl_debug_var.cmake)
include(CMake/fl_debug_pkg.cmake)
include(CMake/fl_add_library.cmake)

# right now we don't use compatibility functions
# include(CMake/compatibility.cmake)

if(0)
  fl_debug_var(FLTK_VERSION_MAJOR)
  fl_debug_var(FLTK_VERSION_MINOR)
  fl_debug_var(FLTK_VERSION_PATCH)
  fl_debug_var(FLTK_VERSION)
  fl_debug_var(CMAKE_VERSION)
endif()

# Set FLTK_VERSION in the cache so user projects can access it,
# for instance if FLTK is built as a subproject (FetchContent)

set(FLTK_VERSION ${FLTK_VERSION} CACHE STRING "FLTK version" FORCE)

#######################################################################
# basic setup
#######################################################################
include(CMake/setup.cmake)

#######################################################################
# check for headers, libraries and functions
#######################################################################
include(CMake/resources.cmake)

#######################################################################
# options
#######################################################################
include(CMake/options.cmake)

#######################################################################
# Disable automatic code signing on macOS when using Xcode.
# This *MUST* be done after including CMake/options.cmake.
# Users can still enable code signing if they have a valid certificate.
# Details about code signing are beyond the scope of this document.
#######################################################################
# FIXME: some of the conditions below may be redundant, and the code
# below should be improved in a later version.
#######################################################################

if(APPLE) # AND NOT FLTK_BACKEND_X11 AND CMAKE_GENERATOR STREQUAL "Xcode")
  if(NOT DEFINED CMAKE_XCODE_ATTRIBUTE_CODE_SIGNING_ALLOWED)
    set(CMAKE_XCODE_ATTRIBUTE_CODE_SIGNING_ALLOWED OFF CACHE BOOL
        "Allow Code Signing when using Xcode")
  endif()
endif()

#######################################################################
# print (debug) several build variables and options
#######################################################################

set(debug_build 0) # set to 1 to show debug info

if(debug_build)
  message("")
  message(STATUS "${CMAKE_CURRENT_LIST_DIR}/CMakeLists.txt: set 'debug_build' to 0 to disable the following info:")
  fl_debug_var(WIN32)
  fl_debug_var(MINGW)
  fl_debug_var(CYGWIN)
  fl_debug_var(MSVC)
  fl_debug_var(UNIX)
  fl_debug_var(APPLE)
  fl_debug_var(CMAKE_BUILD_TYPE)
  fl_debug_var(CMAKE_SIZEOF_VOID_P)
  fl_debug_var(FLTK_OPTION_OPTIM)
  fl_debug_var(CMAKE_C_FLAGS)
  fl_debug_var(CMAKE_CXX_FLAGS)
  fl_debug_var(CMAKE_EXE_LINKER_FLAGS)
  message(STATUS "${CMAKE_CURRENT_LIST_DIR}/CMakeLists.txt: end of debug_build info.")
endif(debug_build)

unset(debug_build)

#######################################################################
# Build a dummy ("empty") Cairo library for backwards compatibility.
# This should be removed in the next minor release after 1.4.x, likely
# in FLTK 1.5.0.
#######################################################################

if(FLTK_HAVE_CAIRO)
  add_subdirectory(cairo)
endif()

#######################################################################
# build the standard FLTK libraries
#######################################################################

add_subdirectory(src)

#######################################################################
# MSVC only: build a special object library for shared libs
#######################################################################

# When linking programs against the shared FLTK libraries we need to
# compile and link with fl_call_main.c, but this must not be compiled
# with macro FL_DLL, whereas all the other source file(s) *must* be
# compiled with macro FL_DLL to link against the shared libs.
# The latter is ensured by CMake properties of the shared libraries.
#
# Solution: build an extra object library with just this one file and
# link all the "shared" executables additionally against this object
# library to resolve the symbol 'WinMain()'.
#
# The object library is called 'call_main' and is available for fluid,
# fltk-options, and all test programs that link against shared FLTK
# libraries when using MSVC (Microsoft Visual Studio).
#
#  ;-)  I *love* Visual Studio  ;-)

if(FLTK_BUILD_SHARED_LIBS AND MSVC)
  add_library(call_main OBJECT EXCLUDE_FROM_ALL src/fl_call_main.c)
endif()

#######################################################################
# set CMAKE_INSTALL_RPATH for shared libraries on macOS before
# building executables. This assumes standard install locations like
#  - prefix/bin   executable (path part 2) or bundle (path part 3)
#  - prefix/lib   shared library
# These RPATH settings are effective when executables and shared libs
# are *installed*, they don't affect executables in the build folder.
# Affected executables (when linked against the shared FLTK libs):
#  - fluid
#  - fltk-options
#  - test/* (e.g. games)
# Note: Path part 1 ("@loader_path") is used to find shared libraries
#       in the same folder as the executable file (everywhere).
#######################################################################

if(FLTK_BUILD_SHARED_LIBS AND APPLE AND NOT FLTK_BACKEND_X11)
  set(CMAKE_INSTALL_RPATH
      @loader_path
      @loader_path/../lib
      @loader_path/../../../../lib)
endif()

#######################################################################
# build fluid (optional)
#######################################################################

set(FLTK_FLUID_EXECUTABLE "")

if(FLTK_BUILD_FLUID)
  add_subdirectory(fluid)
endif(FLTK_BUILD_FLUID)

# Set FLTK_FLUID_EXECUTABLE in the cache for user projects.
# This can be used if FLTK has been built as a subproject.

set(FLTK_FLUID_EXECUTABLE
    "${FLTK_FLUID_EXECUTABLE}" CACHE STRING
    "FLTK's 'fluid' executable")

#######################################################################
# build fltk-options
#######################################################################

if(FLTK_BUILD_FLTK_OPTIONS)
  add_subdirectory(fltk-options)
endif(FLTK_BUILD_FLTK_OPTIONS)

#######################################################################
# variables shared by export and install
# export.cmake creates configuration files for direct use in a built but uninstalled FLTK
# install.cmake creates these files for an installed FLTK
# these two would only differ in paths, so common variables are set here
#######################################################################

include(CMake/variables.cmake)

#######################################################################
# final config and export
#######################################################################

include(CMake/export.cmake)

configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/fl_config.cmake.in
  ${CMAKE_CURRENT_BINARY_DIR}/FL/fl_config.h
  @ONLY
)

#######################################################################
# options to build test/demo and example programs
#######################################################################

if(FLTK_BUILD_TEST)
  add_subdirectory(test)
endif(FLTK_BUILD_TEST)

if(FLTK_BUILD_EXAMPLES)
  add_subdirectory(examples)
endif(FLTK_BUILD_EXAMPLES)

#######################################################################
# Create and install version config file 'FLTKConfigVersion.cmake'
#######################################################################

include(CMakePackageConfigHelpers)

write_basic_package_version_file(FLTKConfigVersion.cmake
  # [VERSION requiredVersion]       # defaults to project version
  COMPATIBILITY SameMinorVersion
)

install(FILES
  ${CMAKE_CURRENT_BINARY_DIR}/FLTKConfigVersion.cmake
  DESTINATION ${FLTK_CONFIG_PATH}
)

#######################################################################
# installation
#######################################################################

include(CMake/install.cmake)

#######################################################################
# Generate Library Export Headers          *** EXPERIMENTAL *** WIP ***
#######################################################################

# Enable (1) or disable (0) generation of experimental headers (WIP)
set(GENERATE_EXPORT_HEADERS 0)

if(FLTK_BUILD_SHARED_LIBS AND GENERATE_EXPORT_HEADERS)

  include(GenerateExportHeader)

  generate_export_header(fltk_SHARED
    BASE_NAME fl
    EXPORT_FILE_NAME FL/fltk_export.h
    STATIC_DEFINE FL_STATIC_LIB
  )

  if(NOT MSVC)

    # Visual Studio builds only one shared lib (DLL)

    generate_export_header(fltk_images_SHARED
      BASE_NAME fl_images
      EXPORT_FILE_NAME FL/fltk_images_export.h
      STATIC_DEFINE FL_STATIC_LIB
    )

    generate_export_header(fltk_forms_SHARED
      BASE_NAME fl_forms
      EXPORT_FILE_NAME FL/fltk_forms_export.h
      STATIC_DEFINE FL_STATIC_LIB
    )

    generate_export_header(fltk_gl_SHARED
      BASE_NAME fl_gl
      EXPORT_FILE_NAME FL/fltk_gl_export.h
      STATIC_DEFINE FL_STATIC_LIB
    )

  endif(NOT MSVC)

endif(FLTK_BUILD_SHARED_LIBS AND GENERATE_EXPORT_HEADERS)

#######################################################################
# Output Build Configuration Summary
#######################################################################

include(FeatureSummary)         # CMake Feature Summary
include(CMake/fl_summary.cmake) # special FLTK summary macros

# CMake Feature Summary

message("")
set(_descr "${PROJECT_NAME} ${FLTK_VERSION} generated by CMake ${CMAKE_VERSION}")
feature_summary(WHAT ALL DESCRIPTION "Configuration Summary for ${_descr} --\n")

# FLTK specific build configuration and options (see macros in fl_summary.cmake)

#                "title"               dir  build (bool)             option to set
fl_summary_build("Static libraries"    lib  TRUE                     "n/a")
fl_summary_build("Shared libraries"    lib  FLTK_BUILD_SHARED_LIBS   FLTK_BUILD_SHARED_LIBS)
fl_summary_build("The forms library"   lib  FLTK_BUILD_FORMS         FLTK_BUILD_FORMS)
fl_summary_build("The OpenGL library"  lib  FLTK_USE_GL              FLTK_BUILD_GL)
fl_summary_build("fluid"               bin  FLTK_BUILD_FLUID         FLTK_BUILD_FLUID)
fl_summary_build("fltk-options"        bin  FLTK_BUILD_FLTK_OPTIONS  FLTK_BUILD_FLTK_OPTIONS)

=== cairo/CMakeLists.txt ===
#
# CMakeLists.txt to build a dummy Cairo library for the FLTK project using CMake
#
# Copyright 1998-2023 by Bill Spitzak and others.
#
# This library is free software. Distribution and use rights are outlined in
# the file "COPYING" which should have been included with this file.  If this
# file is missing or damaged, see the license at:
#
#     https://www.fltk.org/COPYING.php
#
# Please see the following page on how to report bugs and issues:
#
#     https://www.fltk.org/bugs.php
#

########################################################################
# Note: since FLTK 1.4.0 Fl_Cairo_Window support [1] is included in
# libfltk and libfltk_cairo is no longer necessary. This directory is
# used to build an "empty" dummy library for backwards compatibility,
# just in case users expect it to exist.
# ----------------------------------------------------------------------
# The entire 'cairo' folder will be removed in a later FLTK release.
########################################################################

# Build dummy fltk_cairo library

set(cairo_SRCS cairo_dummy.c)

fl_add_library(fltk_cairo STATIC "${cairo_SRCS}")
target_link_libraries(fltk_cairo PUBLIC fltk::fltk)

# Build shared dummy library(optional)

if(FLTK_BUILD_SHARED_LIBS)

  fl_add_library(fltk_cairo SHARED "${cairo_SRCS}")
  target_link_libraries(fltk_cairo-shared PUBLIC fltk::fltk-shared)

endif(FLTK_BUILD_SHARED_LIBS)

set(FLTK_LIBRARIES ${FLTK_LIBRARIES} PARENT_SCOPE)
set(FLTK_LIBRARIES_SHARED ${FLTK_LIBRARIES_SHARED} PARENT_SCOPE)

=== documentation/Makefile ===
#
# Makefile for the Fast Light Tool Kit (FLTK) documentation.
#
# Copyright 1998-2024 by Bill Spitzak and others.
#
# This library is free software. Distribution and use rights are outlined in
# the file "COPYING" which should have been included with this file.  If this
# file is missing or damaged, see the license at:
#
#     https://www.fltk.org/COPYING.php
#
# Please see the following page on how to report bugs and issues:
#
#      https://www.fltk.org/bugs.php
#

# Get configuration stuff...
include ../makeinclude

# make sure that all docs are (re-)created independent of missing deps
.PHONY: pdf html refman.pdf

SRC_DOCDIR      = 	./src

# These are the HTML "source" files...
HTMLFILES	= 	 \
			 $(SRC_DOCDIR)/index.dox \
                         $(SRC_DOCDIR)/preface.dox \
                         $(SRC_DOCDIR)/intro.dox \
                         $(SRC_DOCDIR)/basics.dox \
                         $(SRC_DOCDIR)/common.dox \
                         $(SRC_DOCDIR)/coordinates.dox \
                         $(SRC_DOCDIR)/resize.dox \
                         $(SRC_DOCDIR)/editor.dox \
                         $(SRC_DOCDIR)/drawing.dox \
                         $(SRC_DOCDIR)/events.dox \
                         $(SRC_DOCDIR)/subclassing.dox \
                         $(SRC_DOCDIR)/opengl.dox \
                         $(SRC_DOCDIR)/fltk-options.dox \
                         $(SRC_DOCDIR)/advanced.dox \
                         $(SRC_DOCDIR)/unicode.dox \
                         $(SRC_DOCDIR)/enumerations.dox \
                         $(SRC_DOCDIR)/glut.dox \
                         $(SRC_DOCDIR)/forms.dox \
                         $(SRC_DOCDIR)/osissues.dox \
                         $(SRC_DOCDIR)/migration_1_4.dox \
                         $(SRC_DOCDIR)/development.dox \
                         $(SRC_DOCDIR)/license.dox \
                         $(SRC_DOCDIR)/examples.dox \
                         $(SRC_DOCDIR)/faq.dox \
                         $(SRC_DOCDIR)/Fl_Terminal.dox

MANPAGES =	$(SRC_DOCDIR)/fltk.$(CAT3EXT) $(SRC_DOCDIR)/fltk-config.$(CAT1EXT) \
		$(SRC_DOCDIR)/fluid.$(CAT1EXT) $(SRC_DOCDIR)/blocks.$(CAT6EXT) \
		$(SRC_DOCDIR)/checkers.$(CAT6EXT) $(SRC_DOCDIR)/sudoku.$(CAT6EXT) \
		$(SRC_DOCDIR)/fltk-options.$(CAT1EXT)

# Get FLTK's Git Revision either from Git /or/ from fltk_git_rev.dat (Issue #499)
#
# Note: this may fail (return "unknown") if the sources were downloaded
# from GitHub as a "release" (zip) archive. This is not supported.

# Test/debug only: should be commented out unless used (see: debug_git_rev)
# GIT_REV_FROM_GIT  := "$$(git rev-parse HEAD 2>/dev/null)"
# GIT_REV_FROM_FILE := "$$(cat ../fltk_git_rev.dat 2>/dev/null)"

FLTK_GIT_REVISION := "`( (git rev-parse HEAD || cat ../fltk_git_rev.dat;) || echo 'unknown'; ) 2>/dev/null`"

all:	$(MANPAGES)

# Use `make docs' to create all docs for distribution files.
# You need installed versions of Doxygen and LaTeX for this.

docs:	all html pdf

# Synonyms for docs:

alldocs: docs
dist:	docs

debug_git_rev:
	# echo "GIT_REV_FROM_GIT  = $(GIT_REV_FROM_GIT)"
	# echo "GIT_REV_FROM_FILE = $(GIT_REV_FROM_FILE)"
	echo "FLTK_GIT_REVISION = $(FLTK_GIT_REVISION)"

clean:
	$(RM) Doxyfile Doxybook
	$(RM) copyright.dox generated.dox make_pdf
	$(RM) fltk.pdf refman.pdf src/fltk-title.tex src/fltk-book.tex.in src/fltk-book.tex
	$(RMDIR) html latex
	$(RM) *~ *.bck *.bak *.log
	$(RM) $(MANPAGES) $(SRC_DOCDIR)/*.0

depend:

install: $(MANPAGES)
	echo "Installing documentation files in $(DESTDIR)$(docdir) ..."
	-$(INSTALL_DIR) "$(DESTDIR)$(docdir)"
	if test -f html/index.html ; then \
	  for file in html/* ; do \
		$(INSTALL_DATA) $$file "$(DESTDIR)$(docdir)"; \
	  done \
	fi
	if test -f fltk.pdf ; then \
	  echo "Installing fltk.pdf in $(DESTDIR)$(docdir) ..."; \
	  $(INSTALL_DATA) fltk.pdf "$(DESTDIR)$(docdir)"; \
	fi
	echo "Installing man pages in $(DESTDIR)$(mandir) ..."
	-$(INSTALL_DIR) "$(DESTDIR)$(mandir)/cat1"
	$(INSTALL_MAN) $(SRC_DOCDIR)/fluid.$(CAT1EXT) "$(DESTDIR)$(mandir)/cat1"
	$(INSTALL_MAN) $(SRC_DOCDIR)/fltk-config.$(CAT1EXT) "$(DESTDIR)$(mandir)/cat1"
	$(INSTALL_MAN) $(SRC_DOCDIR)/fltk-options.$(CAT1EXT) "$(DESTDIR)$(mandir)/cat1"
	-$(INSTALL_DIR) "$(DESTDIR)$(mandir)/cat3"
	$(INSTALL_MAN) $(SRC_DOCDIR)/fltk.$(CAT3EXT) "$(DESTDIR)$(mandir)/cat3"
	-$(INSTALL_DIR) "$(DESTDIR)$(mandir)/man1"
	$(INSTALL_MAN) $(SRC_DOCDIR)/fluid.man "$(DESTDIR)$(mandir)/man1/fluid.1"
	$(INSTALL_MAN) $(SRC_DOCDIR)/fltk-config.man "$(DESTDIR)$(mandir)/man1/fltk-config.1"
	$(INSTALL_MAN) $(SRC_DOCDIR)/fltk-options.man "$(DESTDIR)$(mandir)/man1/fltk-options.1"
	-$(INSTALL_DIR) "$(DESTDIR)$(mandir)/man3"
	$(INSTALL_MAN) $(SRC_DOCDIR)/fltk.man "$(DESTDIR)$(mandir)/man3/fltk.3"

install-linux install-osx:
	-$(INSTALL_DIR) "$(DESTDIR)$(mandir)/cat6"
	$(INSTALL_MAN) $(SRC_DOCDIR)/blocks.$(CAT6EXT) "$(DESTDIR)$(mandir)/cat6"
	$(INSTALL_MAN) $(SRC_DOCDIR)/checkers.$(CAT6EXT) "$(DESTDIR)$(mandir)/cat6"
	$(INSTALL_MAN) $(SRC_DOCDIR)/sudoku.$(CAT6EXT) "$(DESTDIR)$(mandir)/cat6"
	-$(INSTALL_DIR) "$(DESTDIR)$(mandir)/man6"
	$(INSTALL_MAN) $(SRC_DOCDIR)/blocks.man "$(DESTDIR)$(mandir)/man6/blocks.6"
	$(INSTALL_MAN) $(SRC_DOCDIR)/checkers.man "$(DESTDIR)$(mandir)/man6/checkers.6"
	$(INSTALL_MAN) $(SRC_DOCDIR)/sudoku.man "$(DESTDIR)$(mandir)/man6/sudoku.6"


uninstall:
	$(RMDIR) "$(DESTDIR)$(docdir)"
	$(RM) "$(DESTDIR)$(mandir)/cat1/fluid.$(CAT1EXT)"
	$(RM) "$(DESTDIR)$(mandir)/man1/fluid.1"
	$(RM) "$(DESTDIR)$(mandir)/cat1/fltk-config.$(CAT1EXT)"
	$(RM) "$(DESTDIR)$(mandir)/man1/fltk-config.1"
	$(RM) "$(DESTDIR)$(mandir)/cat1/fltk-options.$(CAT1EXT)"
	$(RM) "$(DESTDIR)$(mandir)/man1/fltk-options.1"
	$(RM) "$(DESTDIR)$(mandir)/cat3/fltk.$(CAT3EXT)"
	$(RM) "$(DESTDIR)$(mandir)/man3/fltk.3"

uninstall-linux uninstall-osx:
	$(RM) "$(DESTDIR)$(mandir)/cat6/blocks.$(CAT6EXT)"
	$(RM) "$(DESTDIR)$(mandir)/cat6/checkers.$(CAT6EXT)"
	$(RM) "$(DESTDIR)$(mandir)/cat6/sudoku.$(CAT6EXT)"
	$(RM) "$(DESTDIR)$(mandir)/man6/blocks.6"
	$(RM) "$(DESTDIR)$(mandir)/man6/checkers.6"
	$(RM) "$(DESTDIR)$(mandir)/man6/sudoku.6"

# The documentation is generated using doxygen. There are two control files
# for doxygen: Doxyfile for html documentation and Doxybook for pdf docs.
# Both files are generated from the common source file Doxyfile.in.
# Note that Doxyfile.in is shared with CMake to configure these files.

# Note: There's no way to enable the "Driver Documentation" via configure+make,
#       please use CMake 'FLTK_INCLUDE_DRIVER_DOCS' instead.
#       Alternatively (if you really need it) edit this Makefile and
#       replace the two lines below containing "@DRIVER_DOCS@" to read:
#	    -e's, @DRIVER_DOCS@, DriverDev,' \
#       (w/o leading '#') to enable the "Driver Documentation" section.
#       Please take care of copying tabs and spaces literally.
# Note: There's no intention to enable this via configure option (use CMake).

Doxyfile: Doxyfile.in generated.dox copyright.dox
	echo "Generating Doxyfile ..."
	./convert_doxyfile "$(DOXYDOC)" $< $@ Doxyfile_error.log
	sed -e's,@FLTK_VERSION@,$(FLTK_VERSION),' \
	    -e's,@GENERATE_HTML@,YES,' \
	    -e's,@GENERATE_LATEX@,NO,' \
	    -e's, @LATEX_HEADER@,,' \
	    -e's, @DRIVER_DOCS@,,' \
	    -e's,@CMAKE_CURRENT_SOURCE_DIR@,.,' \
	    -e's,@CMAKE_CURRENT_BINARY_DIR@,,' \
	    -e's,@FLTK_SOURCE_DIR@,..,' \
	    -i $@

Doxybook: Doxyfile.in generated.dox copyright.dox
	echo "Generating Doxybook ..."
	./convert_doxyfile "$(DOXYDOC)" $< $@ Doxybook_error.log
	sed -e's,@FLTK_VERSION@,$(FLTK_VERSION),' \
	    -e's,@GENERATE_HTML@,NO,' \
	    -e's,@GENERATE_LATEX@,YES,' \
	    -e's,@LATEX_HEADER@,src/fltk-book.tex,' \
	    -e's, @DRIVER_DOCS@,,' \
	    -e's,@CMAKE_CURRENT_SOURCE_DIR@,.,' \
	    -e's,@CMAKE_CURRENT_BINARY_DIR@,,' \
	    -e's,@FLTK_SOURCE_DIR@,..,' \
	    -i $@

# The HTML files are generated using doxygen, and this needs
# an installed doxygen version and may take some time, so this target
# is not made by default.
# Use `make html' or `make docs' to create the html docs.

html:	$(HTMLFILES) Doxyfile
	echo "Generating HTML documentation..."
	-$(RMDIR) html
	-$(INSTALL_DIR) html
	-"$(DOXYDOC)"
	if test "x$(DOXYDOC)" = "x" ; then \
	  echo "Sorry - doxygen not found. Please install doxygen and run configure."; \
	fi

# The PDF documentation (fltk.pdf) is generated using doxygen and LaTeX, and
# this needs installed Doxygen and LaTeX programs and may take some time, so
# this target is not made by default.
# Use `make pdf' or `make docs' to create the PDF docs.

pdf:	refman.pdf
	cp -f latex/refman.pdf fltk.pdf

refman.pdf: $(HTMLFILES) Doxybook src/fltk-book.tex make_pdf
	-$(RMDIR) latex
	echo "Generating PDF documentation ..."
	"$(DOXYDOC)" Doxybook
	./make_pdf

make_pdf: make_pdf.in
	echo "Generating $@ ..."
	PDF_DATE=`date +D:%Y%m%d%H%M%S`; \
	sed -e"s/@PDF_DATE@/$$PDF_DATE/g" \
	    < $< > $@
	chmod +x $@

src/fltk-title.tex: src/fltk-title.tex.in
	echo "Generating $@ ..."
	TODAY=`LC_ALL=C date '+%B %e, %Y'`; \
	sed -e"s/@FLTK_GIT_REVISION@/$(FLTK_GIT_REVISION)/g" \
	    -e"s/@TODAY@/$$TODAY/g" \
	    < $< > $@

src/fltk-book.tex.in: src/fltk-title.tex
	echo "Generating $@ ..."
	./make_header "$(DOXYDOC)" $< $@

src/fltk-book.tex: src/fltk-book.tex.in
	echo "Generating $@ ..."
	DOXY_VERSION=`"$(DOXYDOC)" --version|cut -f1 -d' '`; \
	YEAR=`date +%Y`; \
	sed -e"s/@YEAR@/$$YEAR/g" \
	    -e"s/@FLTK_VERSION@/$(FLTK_VERSION)/g" \
	    -e"s/@DOXY_VERSION@/$$DOXY_VERSION/g" \
	    < $< > $@

generated.dox: generated.dox.in
	echo "Generating $@ ..."
	CURRENT_DATE=`LC_ALL=C date "+%b %d, %Y"`; \
	DOXYGEN_VERSION_SHORT=`"$(DOXYDOC)" --version|cut -f1 -d' '`; \
	sed -e"s/@CURRENT_DATE@/$$CURRENT_DATE/g" \
	    -e"s/@FLTK_GIT_REVISION@/$(FLTK_GIT_REVISION)/g" \
	    -e"s/@DOXYGEN_VERSION_SHORT@/$$DOXYGEN_VERSION_SHORT/g" \
	    < $< > $@

copyright.dox: copyright.dox.in
	echo "Generating $@ ..."
	YEAR=`date +%Y`; \
	sed -e"s/@YEAR@/$$YEAR/g" \
	    < $< > $@

=== examples/Makefile ===
#
# Makefile used to build example apps by 'make'
#
# Copyright 2020-2022 by Bill Spitzak and others.
#
# This library is free software. Distribution and use rights are outlined in
# the file "COPYING" which should have been included with this file.  If this
# file is missing or damaged, see the license at:
#
#     https://www.fltk.org/COPYING.php
#
# Please see the following page on how to report bugs and issues:
#
#     https://www.fltk.org/bugs.php
#
################################################################################

include Makefile.FLTK

RM    = rm -f
SHELL = /bin/sh
.SILENT:

# Executables
ALL = animgifimage$(EXEEXT) \
      animgifimage-play$(EXEEXT) \
      animgifimage-simple$(EXEEXT) \
      animgifimage-resize$(EXEEXT) \
      browser-simple$(EXEEXT) \
      cairo-draw-x$(EXEEXT) \
      callbacks$(EXEEXT) \
      chart-simple$(EXEEXT) \
      draggable-group$(EXEEXT) \
      grid-simple$(EXEEXT) \
      howto-add_fd-and-popen$(EXEEXT) \
      howto-browser-with-icons$(EXEEXT) \
      howto-drag-and-drop$(EXEEXT) \
      howto-draw-an-x$(EXEEXT) \
      howto-flex-simple$(EXEEXT) \
      howto-menu-with-images$(EXEEXT) \
      howto-parse-args$(EXEEXT) \
      howto-remap-numpad-keyboard-keys$(EXEEXT) \
      howto-simple-svg$(EXEEXT) \
      howto-text-over-image-button$(EXEEXT) \
      menubar-add$(EXEEXT) \
      nativefilechooser-simple-app$(EXEEXT) \
      nativefilechooser-simple$(EXEEXT) \
      progress-simple$(EXEEXT) \
      shapedwindow$(EXEEXT) \
      simple-terminal$(EXEEXT) \
      table-as-container$(EXEEXT) \
      table-simple$(EXEEXT) \
      table-sort$(EXEEXT) \
      table-spreadsheet$(EXEEXT) \
      table-spreadsheet-with-keyboard-nav$(EXEEXT) \
      table-with-keynav$(EXEEXT) \
      table-with-right-column-stretch-fit$(EXEEXT) \
      table-with-right-click-menu$(EXEEXT) \
      tabs-simple$(EXEEXT) \
      textdisplay-with-colors$(EXEEXT) \
      texteditor-simple$(EXEEXT) \
      texteditor-with-dynamic-colors$(EXEEXT) \
      tree-as-container$(EXEEXT) \
      tree-custom-draw-items$(EXEEXT) \
      tree-custom-sort$(EXEEXT) \
      tree-of-tables$(EXEEXT) \
      tree-simple$(EXEEXT) \
      wizard-simple$(EXEEXT)

# default target -- build everything
default all: $(ALL)

# Special rules for building cairo app
cairo-draw-x.o: cairo-draw-x.cxx
	@echo "*** Compile $<..."
	$(CXX) -I.. $(CXXFLAGS_CAIRO) -c $< -o $@
cairo-draw-x$(EXEEXT): cairo-draw-x.o
	@echo "*** Link $<..."
	$(CXX) $< $(LINKFLTK) $(LINKFLTK_CAIRO) -o $@

# clean everything
clean:
	$(RM) $(ALL)
	$(RM) *.o
	$(RM) core

=== jpeg/Makefile ===
# *************************************************************************
#  FLTK - DO NOT CHANGE when upgrading the JPEG library, unless required. *
# *************************************************************************
#
# JPEG library makefile for the Fast Light Toolkit (FLTK).
#
# Copyright 1997-2024 by Bill Spitzak and others.
#
# This library is free software. Distribution and use rights are outlined in
# the file "COPYING" which should have been included with this file.  If this
# file is missing or damaged, see the license at:
#
#     https://www.fltk.org/COPYING.php
#
# Please see the following page on how to report bugs and issues:
#
#     https://www.fltk.org/bugs.php
#

include ../makeinclude

#
# Object files...
#

OBJS	=	\
		jaricom.o \
		jcapimin.o \
		jcapistd.o \
		jcarith.o \
		jccoefct.o \
		jccolor.o \
		jcdctmgr.o \
		jchuff.o \
		jcinit.o \
		jcmainct.o \
		jcmarker.o \
		jcmaster.o \
		jcomapi.o \
		jcparam.o \
		jcprepct.o \
		jcsample.o \
		jctrans.o \
		jdapimin.o \
		jdapistd.o \
		jdarith.o \
		jdatadst.o \
		jdatasrc.o \
		jdcoefct.o \
		jdcolor.o \
		jddctmgr.o \
		jdhuff.o \
		jdinput.o \
		jdmainct.o \
		jdmarker.o \
		jdmaster.o \
		jdmerge.o \
		jdpostct.o \
		jdsample.o \
		jdtrans.o \
		jerror.o \
		jfdctflt.o \
		jfdctfst.o \
		jfdctint.o \
		jidctflt.o \
		jidctfst.o \
		jidctint.o \
		jmemmgr.o \
		jmemnobs.o \
		jquant1.o \
		jquant2.o \
		jutils.o

LIBJPEG	=	../lib/libfltk_jpeg$(LIBEXT)

#
# Make all targets...
#

all:	$(LIBJPEG)

#
# Clean all targets and object files...
#

clean:
	$(RM) $(OBJS)
	$(RM) $(LIBJPEG)

#
# Install everything...
#

install:	$(LIBJPEG)
	echo "Installing $(LIBJPEG) in $(libdir)..."
	-$(INSTALL_DIR) "$(DESTDIR)$(libdir)"
	$(INSTALL_LIB) $(LIBJPEG) "$(DESTDIR)$(libdir)"
	$(RANLIB) "$(DESTDIR)$(libdir)/libfltk_jpeg$(LIBEXT)"
	echo "Installing jpeg headers in $(includedir)/FL/images..."
	-$(INSTALL_DIR) "$(DESTDIR)$(includedir)/FL/images"
	$(INSTALL_DATA) jconfig.h "$(DESTDIR)$(includedir)/FL/images"
	$(INSTALL_DATA) jerror.h "$(DESTDIR)$(includedir)/FL/images"
	$(INSTALL_DATA) jmorecfg.h "$(DESTDIR)$(includedir)/FL/images"
	$(INSTALL_DATA) jpeglib.h "$(DESTDIR)$(includedir)/FL/images"
	$(INSTALL_DATA) fltk_jpeg_prefix.h "$(DESTDIR)$(includedir)/FL/images"

#
# Uninstall everything...
#

uninstall:
	echo "Uninstalling libfltk_jpeg$(LIBEXT) in $(libdir)..."
	$(RM) "$(libdir)/libfltk_jpeg$(LIBEXT)"
	echo "Uninstalling jpeg headers in $(includedir)/FL/images..."
	$(RM) "$(includedir)/FL/images/jconfig.h"
	$(RM) "$(includedir)/FL/images/jerror.h"
	$(RM) "$(includedir)/FL/images/jmorecfg.h"
	$(RM) "$(includedir)/FL/images/jpeglib.h"
	$(RM) "$(includedir)/FL/images/fltk_jpeg_prefix.h"

#
# libfltk_jpeg.a
#

$(LIBJPEG):	$(OBJS)
	echo Archiving $@...
	$(RM) $@
	$(LIBCOMMAND) $@ $(OBJS)
	$(RANLIB) $@

#
# Make dependencies...
#

depend:	$(OBJS:.o=.c)
	makedepend -Y -I.. -f makedepend -w 20 $(OBJS:.o=.c)
	echo "# DO NOT DELETE THIS LINE -- make depend depends on it." > makedepend.tmp
	echo "" >> makedepend.tmp
	grep '^[a-zA-Z]' makedepend | ( LC_ALL=C sort -u -f >> makedepend.tmp; )
	mv makedepend.tmp makedepend

include makedepend

$(OBJS):	../makeinclude

=== src/CMakeLists.txt ===
#
# CMakeLists.txt to build the FLTK library using CMake (www.cmake.org)
#
# Copyright 1998-2025 by Bill Spitzak and others.
#
# This library is free software. Distribution and use rights are outlined in
# the file "COPYING" which should have been included with this file.  If this
# file is missing or damaged, see the license at:
#
#     https://www.fltk.org/COPYING.php
#
# Please see the following page on how to report bugs and issues:
#
#     https://www.fltk.org/bugs.php
#

# Local macro to check existence of a required file with warning message
#
# In:  FILENAME (string): File to search
# Out: WARN     (string): *Name* of a variable that is set to true if NOT found
#
# Set variable ${WARN} to FALSE before calling this macro

macro(fl_check_required_file WARN FILENAME)
  if(NOT EXISTS ${FILENAME})
    message("*** Required file not found: ${FILENAME} ***")
    set(${WARN} TRUE)
  endif()
endmacro(fl_check_required_file WARN FILENAME)

set(CPPFILES
  Fl.cxx
  Fl_Adjuster.cxx
  Fl_Bitmap.cxx
  Fl_Browser.cxx
  Fl_Browser_.cxx
  Fl_Browser_load.cxx
  Fl_Box.cxx
  Fl_Button.cxx
  Fl_Chart.cxx
  Fl_Check_Browser.cxx
  Fl_Check_Button.cxx
  Fl_Choice.cxx
  Fl_Clock.cxx
  Fl_Color_Chooser.cxx
  Fl_Copy_Surface.cxx
  Fl_Counter.cxx
  Fl_Device.cxx
  Fl_Dial.cxx
  Fl_Double_Window.cxx
  Fl_File_Browser.cxx
  Fl_File_Chooser.cxx
  Fl_File_Chooser2.cxx
  Fl_File_Icon.cxx
  Fl_File_Input.cxx
  Fl_Flex.cxx
  Fl_Graphics_Driver.cxx
  Fl_Grid.cxx
  Fl_Group.cxx
  Fl_Help_View.cxx
  Fl_Image.cxx
  Fl_Image_Surface.cxx
  Fl_Input.cxx
  Fl_Input_.cxx
  Fl_Input_Choice.cxx
  Fl_Int_Vector.cxx
  Fl_Light_Button.cxx
  Fl_Menu.cxx
  Fl_Menu_.cxx
  Fl_Menu_Bar.cxx
  Fl_Menu_Button.cxx
  Fl_Menu_Window.cxx
  Fl_Menu_add.cxx
  Fl_Menu_global.cxx
  Fl_Message.cxx
  Fl_Multi_Label.cxx
  Fl_Native_File_Chooser.cxx
  Fl_Overlay_Window.cxx
  Fl_Pack.cxx
  Fl_Paged_Device.cxx
  Fl_Pixmap.cxx
  Fl_Positioner.cxx
  Fl_Preferences.cxx
  Fl_Printer.cxx
  Fl_Progress.cxx
  Fl_Repeat_Button.cxx
  Fl_Return_Button.cxx
  Fl_Roller.cxx
  Fl_Round_Button.cxx
  Fl_Scheme.cxx
  Fl_Scheme_Choice.cxx
  Fl_Screen_Driver.cxx
  Fl_Scroll.cxx
  Fl_Scrollbar.cxx
  Fl_Shared_Image.cxx
  Fl_Shortcut_Button.cxx
  Fl_Single_Window.cxx
  Fl_Slider.cxx
  Fl_Spinner.cxx
  Fl_String.cxx
  Fl_Sys_Menu_Bar.cxx
  Fl_System_Driver.cxx
  Fl_Table.cxx
  Fl_Table_Row.cxx
  Fl_Tabs.cxx
  Fl_Terminal.cxx
  Fl_Text_Buffer.cxx
  Fl_Text_Display.cxx
  Fl_Text_Editor.cxx
  Fl_Tile.cxx
  Fl_Tiled_Image.cxx
  Fl_Timeout.cxx
  Fl_Tooltip.cxx
  Fl_Tree.cxx
  Fl_Tree_Item_Array.cxx
  Fl_Tree_Item.cxx
  Fl_Tree_Prefs.cxx
  Fl_Valuator.cxx
  Fl_Value_Input.cxx
  Fl_Value_Output.cxx
  Fl_Value_Slider.cxx
  Fl_Widget.cxx
  Fl_Widget_Surface.cxx
  Fl_Window.cxx
  Fl_Window_Driver.cxx
  Fl_Window_fullscreen.cxx
  Fl_Window_hotspot.cxx
  Fl_Window_iconize.cxx
  Fl_Wizard.cxx
  Fl_XBM_Image.cxx
  Fl_XPM_Image.cxx
  Fl_abort.cxx
  Fl_add_idle.cxx
  Fl_arg.cxx
  Fl_compose.cxx
  Fl_display.cxx
  Fl_get_system_colors.cxx
  Fl_grab.cxx
  Fl_lock.cxx
  Fl_own_colormap.cxx
  Fl_visual.cxx
  filename_absolute.cxx
  filename_expand.cxx
  filename_ext.cxx
  filename_isdir.cxx
  filename_list.cxx
  filename_match.cxx
  filename_setext.cxx
  fl_arc.cxx
  fl_ask.cxx
  fl_boxtype.cxx
  fl_color.cxx
  fl_contrast.cxx
  fl_cursor.cxx
  fl_curve.cxx
  fl_diamond_box.cxx
  fl_draw.cxx
  fl_draw_arrow.cxx
  fl_draw_pixmap.cxx
  fl_encoding_latin1.cxx
  fl_encoding_mac_roman.cxx
  fl_engraved_label.cxx
  fl_file_dir.cxx
  fl_font.cxx
  fl_gleam.cxx
  fl_gtk.cxx
  fl_labeltype.cxx
  fl_open_uri.cxx
  fl_oval_box.cxx
  fl_overlay.cxx
  fl_oxy.cxx
  fl_plastic.cxx
  fl_read_image.cxx
  fl_rect.cxx
  fl_round_box.cxx
  fl_rounded_box.cxx
  fl_set_font.cxx
  fl_scroll_area.cxx
  fl_shadow_box.cxx
  fl_shortcut.cxx
  fl_show_colormap.cxx
  fl_string_functions.cxx
  fl_symbols.cxx
  fl_utf8.cxx
  fl_vertex.cxx
  print_button.cxx
  screen_xywh.cxx
)

if(FLTK_HAVE_CAIRO) # FLTK_OPTION_CAIRO_WINDOW or FLTK_OPTION_CAIRO_EXT
  list(APPEND CPPFILES Fl_Cairo.cxx)
endif()

# find all header files in source directory <FL/...>
file(GLOB
  HEADER_FILES
  "../FL/*.[hH]"
)

# add generated header files in build directory
list(APPEND HEADER_FILES
  ${CMAKE_CURRENT_BINARY_DIR}/../FL/fl_config.h
  ${CMAKE_CURRENT_BINARY_DIR}/../config.h
)

set(GL_HEADER_FILES)  # FIXME: not (yet?) defined

if(FLTK_USE_X11 AND NOT FLTK_OPTION_PRINT_SUPPORT)
  set(PSFILES)
else()
  set(PSFILES
    drivers/PostScript/Fl_PostScript.cxx
    drivers/PostScript/Fl_PostScript_image.cxx
  )
endif(FLTK_USE_X11 AND NOT FLTK_OPTION_PRINT_SUPPORT)

set(DRIVER_FILES)

if(FLTK_USE_X11 AND NOT FLTK_BACKEND_WAYLAND)

  # X11 (including APPLE with X11)

  set(DRIVER_FILES
    drivers/Posix/Fl_Posix_Printer_Driver.cxx
    drivers/X11/Fl_X11_Screen_Driver.cxx
    drivers/X11/Fl_X11_Window_Driver.cxx
    drivers/Posix/Fl_Posix_System_Driver.cxx
    drivers/Unix/Fl_Unix_System_Driver.cxx
    drivers/Unix/Fl_Unix_Screen_Driver.cxx
    drivers/Xlib/Fl_Xlib_Copy_Surface_Driver.cxx
    drivers/Xlib/Fl_Xlib_Image_Surface_Driver.cxx
    drivers/X11/fl_X11_platform_init.cxx
    Fl_x.cxx
    fl_dnd_x.cxx
    Fl_Native_File_Chooser_FLTK.cxx
    Fl_Native_File_Chooser_GTK.cxx
    Fl_get_key.cxx
  )

    list(APPEND DRIVER_FILES
      Fl_Native_File_Chooser_Kdialog.cxx
      Fl_Native_File_Chooser_Zenity.cxx)

  if(FLTK_USE_CAIRO)
    list(APPEND DRIVER_FILES
      drivers/Cairo/Fl_Cairo_Graphics_Driver.cxx
      drivers/Cairo/Fl_X11_Cairo_Graphics_Driver.cxx
    )
  else()
    if(USE_XFT)
      list(APPEND DRIVER_FILES
        drivers/Xlib/Fl_Xlib_Graphics_Driver_font_xft.cxx
      )
      if(USE_PANGO)
        list(APPEND DRIVER_FILES drivers/Cairo/Fl_Cairo_Graphics_Driver.cxx)
      endif(USE_PANGO)
    else()
      list(APPEND DRIVER_FILES
        drivers/Xlib/Fl_Xlib_Graphics_Driver_font_x.cxx
      )
    endif(USE_XFT)
    list(APPEND DRIVER_FILES
      drivers/Xlib/Fl_Xlib_Graphics_Driver.cxx
      drivers/Xlib/Fl_Xlib_Graphics_Driver_arci.cxx
      drivers/Xlib/Fl_Xlib_Graphics_Driver_color.cxx
      drivers/Xlib/Fl_Xlib_Graphics_Driver_image.cxx
      drivers/Xlib/Fl_Xlib_Graphics_Driver_line_style.cxx
      drivers/Xlib/Fl_Xlib_Graphics_Driver_rect.cxx
      drivers/Xlib/Fl_Xlib_Graphics_Driver_vertex.cxx
    )
  endif(FLTK_USE_CAIRO)

  set(DRIVER_HEADER_FILES
    drivers/Posix/Fl_Posix_System_Driver.H
    drivers/X11/Fl_X11_Screen_Driver.H
    drivers/X11/Fl_X11_Window_Driver.H
    drivers/Xlib/Fl_Xlib_Graphics_Driver.H
    drivers/Xlib/Fl_Font.H
    drivers/Xlib/Fl_Xlib_Copy_Surface_Driver.H
    drivers/Xlib/Fl_Xlib_Image_Surface_Driver.H
    drivers/Unix/Fl_Unix_System_Driver.H
 )
 if(FLTK_USE_CAIRO)
   set(DRIVER_HEADER_FILES ${DRIVER_HEADER_FILES}
     drivers/Cairo/Fl_Cairo_Graphics_Driver.H
     drivers/Cairo/Fl_X11_Cairo_Graphics_Driver.H
   )
 elseif(USE_PANGO)
   set(DRIVER_HEADER_FILES ${DRIVER_HEADER_FILES}
     drivers/Cairo/Fl_Cairo_Graphics_Driver.H
   )
 endif(FLTK_USE_CAIRO)

elseif(FLTK_BACKEND_WAYLAND)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -I${CMAKE_CURRENT_BINARY_DIR}")
  set(DRIVER_FILES
    drivers/Posix/Fl_Posix_System_Driver.cxx
    drivers/Posix/Fl_Posix_Printer_Driver.cxx
    drivers/Unix/Fl_Unix_Screen_Driver.cxx
    drivers/Wayland/Fl_Wayland_Screen_Driver.cxx
    drivers/Wayland/Fl_Wayland_Window_Driver.cxx
    drivers/Unix/Fl_Unix_System_Driver.cxx
    drivers/Wayland/Fl_Wayland_Graphics_Driver.cxx
    drivers/Wayland/Fl_Wayland_Copy_Surface_Driver.cxx
    drivers/Wayland/Fl_Wayland_Image_Surface_Driver.cxx
    drivers/Wayland/fl_wayland_clipboard_dnd.cxx
    drivers/Wayland/fl_wayland_platform_init.cxx
    drivers/Cairo/Fl_Cairo_Graphics_Driver.cxx
    Fl_Native_File_Chooser_FLTK.cxx
    Fl_Native_File_Chooser_GTK.cxx
  )

    list(APPEND DRIVER_FILES
      Fl_Native_File_Chooser_Kdialog.cxx
      Fl_Native_File_Chooser_Zenity.cxx)

  if(FLTK_USE_X11)
    list(APPEND DRIVER_FILES
      drivers/Cairo/Fl_X11_Cairo_Graphics_Driver.cxx
      drivers/X11/Fl_X11_Screen_Driver.cxx
      drivers/X11/Fl_X11_Window_Driver.cxx
      drivers/Xlib/Fl_Xlib_Copy_Surface_Driver.cxx
      drivers/Xlib/Fl_Xlib_Image_Surface_Driver.cxx
      Fl_x.cxx
      fl_dnd_x.cxx
      Fl_get_key.cxx
    )
  endif(FLTK_USE_X11)

  set(DRIVER_HEADER_FILES
    drivers/Posix/Fl_Posix_System_Driver.H
    drivers/Wayland/Fl_Wayland_Screen_Driver.H
    drivers/Wayland/Fl_Wayland_Window_Driver.H
    drivers/Wayland/Fl_Wayland_Graphics_Driver.H
    drivers/Cairo/Fl_Cairo_Graphics_Driver.H
    drivers/Cairo/Fl_X11_Cairo_Graphics_Driver.H
    drivers/Wayland/Fl_Wayland_Copy_Surface_Driver.H
    drivers/Wayland/Fl_Wayland_Image_Surface_Driver.H
    drivers/Unix/Fl_Unix_System_Driver.H
  )

elseif(APPLE)

  # Apple Quartz

  set(DRIVER_FILES
    drivers/Quartz/Fl_Quartz_Graphics_Driver.cxx
    drivers/Quartz/Fl_Quartz_Graphics_Driver_color.cxx
    drivers/Quartz/Fl_Quartz_Graphics_Driver_rect.cxx
    drivers/Quartz/Fl_Quartz_Graphics_Driver_font.cxx
    drivers/Quartz/Fl_Quartz_Graphics_Driver_vertex.cxx
    drivers/Quartz/Fl_Quartz_Graphics_Driver_image.cxx
    drivers/Quartz/Fl_Quartz_Graphics_Driver_arci.cxx
    drivers/Quartz/Fl_Quartz_Graphics_Driver_line_style.cxx
    drivers/Quartz/Fl_Quartz_Copy_Surface_Driver.cxx
    drivers/Quartz/Fl_Quartz_Image_Surface_Driver.cxx
    drivers/Cocoa/Fl_Cocoa_Window_Driver.cxx
    drivers/Cocoa/Fl_Cocoa_Screen_Driver.cxx
    drivers/Posix/Fl_Posix_System_Driver.cxx
    drivers/Darwin/Fl_Darwin_System_Driver.cxx
    Fl_get_key_mac.cxx
    drivers/Darwin/fl_macOS_platform_init.cxx
  )
  set(DRIVER_HEADER_FILES
    drivers/Posix/Fl_Posix_System_Driver.H
    drivers/Darwin/Fl_Darwin_System_Driver.H
    drivers/Cocoa/Fl_Cocoa_Screen_Driver.H
    drivers/Cocoa/Fl_Cocoa_Window_Driver.H
    drivers/Cocoa/Fl_MacOS_Sys_Menu_Bar_Driver.H
    drivers/Quartz/Fl_Quartz_Graphics_Driver.H
    drivers/Quartz/Fl_Quartz_Copy_Surface_Driver.H
    drivers/Quartz/Fl_Font.H
    drivers/Quartz/Fl_Quartz_Image_Surface_Driver.H
  )

else()

  # Windows (GDI)

  set(DRIVER_FILES
    drivers/WinAPI/Fl_WinAPI_System_Driver.cxx
    drivers/WinAPI/Fl_WinAPI_Screen_Driver.cxx
    drivers/WinAPI/Fl_WinAPI_Window_Driver.cxx
    drivers/WinAPI/Fl_WinAPI_Printer_Driver.cxx
    drivers/GDI/Fl_GDI_Graphics_Driver.cxx
    drivers/GDI/Fl_GDI_Graphics_Driver_arci.cxx
    drivers/GDI/Fl_GDI_Graphics_Driver_color.cxx
    drivers/GDI/Fl_GDI_Graphics_Driver_font.cxx
    drivers/GDI/Fl_GDI_Graphics_Driver_image.cxx
    drivers/GDI/Fl_GDI_Graphics_Driver_line_style.cxx
    drivers/GDI/Fl_GDI_Graphics_Driver_rect.cxx
    drivers/GDI/Fl_GDI_Graphics_Driver_vertex.cxx
    drivers/GDI/Fl_GDI_Copy_Surface_Driver.cxx
    drivers/GDI/Fl_GDI_Image_Surface_Driver.cxx
    Fl_win32.cxx
    fl_dnd_win32.cxx
    Fl_Native_File_Chooser_WIN32.cxx
    Fl_get_key_win32.cxx
    drivers/WinAPI/fl_WinAPI_platform_init.cxx
  )
  set(DRIVER_HEADER_FILES
    drivers/WinAPI/Fl_WinAPI_System_Driver.H
    drivers/WinAPI/Fl_WinAPI_Screen_Driver.H
    drivers/WinAPI/Fl_WinAPI_Window_Driver.H
    drivers/GDI/Fl_GDI_Graphics_Driver.H
    drivers/GDI/Fl_Font.H
    drivers/GDI/Fl_GDI_Copy_Surface_Driver.H
    drivers/GDI/Fl_GDI_Image_Surface_Driver.H
  )

endif(FLTK_USE_X11 AND NOT FLTK_BACKEND_WAYLAND)

source_group("Header Files" FILES ${HEADER_FILES})
source_group("Driver Source Files" FILES ${DRIVER_FILES})
source_group("Driver Header Files" FILES ${DRIVER_HEADER_FILES})

set(CPPFILES
  ${CPPFILES}
  ${DRIVER_FILES}
)

if(FLTK_BUILD_FORMS)
  set(FORMS_FILES
    forms_compatibility.cxx
    forms_bitmap.cxx
    forms_free.cxx
    forms_fselect.cxx
    forms_pixmap.cxx
    forms_timer.cxx
  )
else()
  set(FORMS_FILES "")
endif()

set(GLCPPFILES
  Fl_Gl_Choice.cxx
  Fl_Gl_Device_Plugin.cxx
  Fl_Gl_Overlay.cxx
  Fl_Gl_Window.cxx
  freeglut_geometry.cxx
  freeglut_stroke_mono_roman.cxx
  freeglut_stroke_roman.cxx
  freeglut_teapot.cxx
  gl_draw.cxx
  gl_start.cxx
  glut_compatibility.cxx
  glut_font.cxx
)

set(GL_DRIVER_FILES
  drivers/OpenGL/Fl_OpenGL_Display_Device.cxx

=== zlib/Makefile ===
#
# ZIP library makefile for the Fast Light Toolkit (FLTK).
#
# Copyright 1998-2023 by Bill Spitzak and others.
#
# This library is free software. Distribution and use rights are outlined in
# the file "COPYING" which should have been included with this file.  If this
# file is missing or damaged, see the license at:
#
#     https://www.fltk.org/COPYING.php
#
# Please see the following page on how to report bugs and issues:
#
#     https://www.fltk.org/bugs.php
#

include ../makeinclude

#
# Object files...
#

OBJS	=	adler32.o compress.o crc32.o uncompr.o deflate.o \
		trees.o zutil.o inflate.o inftrees.o inffast.o \
		gzclose.o gzlib.o gzread.o gzwrite.o infback.o

LIBZ	=	../lib/libfltk_z$(LIBEXT)

#
# Make all targets...
#

all:	$(LIBZ)

#
# Clean all targets and object files...
#

clean:
	$(RM) $(OBJS)
	$(RM) $(LIBZ)

#
# Install everything...
#

install: $(LIBZ)
	echo "Installing libfltk_z$(LIBEXT) in $(libdir)..."
	-$(INSTALL_DIR) "$(DESTDIR)$(libdir)"
	$(INSTALL_LIB) $(LIBZ) "$(DESTDIR)$(libdir)"
	$(RANLIB) "$(DESTDIR)$(libdir)/libfltk_z$(LIBEXT)"
	echo "Installing zlib headers in $(includedir)/FL/images..."
	-$(INSTALL_DIR) "$(DESTDIR)$(includedir)/FL/images"
	$(INSTALL_DATA) zconf.h "$(DESTDIR)$(includedir)/FL/images"
	$(INSTALL_DATA) zlib.h "$(DESTDIR)$(includedir)/FL/images"
	$(INSTALL_DATA) zutil.h "$(DESTDIR)$(includedir)/FL/images"

#
# Uninstall everything...
#

uninstall:
	echo "Uninstalling libfltk_z$(LIBEXT) in $(libdir)..."
	$(RM) "$(libdir)/libfltk_z$(LIBEXT)"
	echo "Uninstalling zlib headers in $(includedir)/FL/images..."
	$(RM) "$(includedir)/FL/images/zconf.h"
	$(RM) "$(includedir)/FL/images/zlib.h"
	$(RM) "$(includedir)/FL/images/zutil.h"

#
# libfltk_z.a
#

$(LIBZ):	$(OBJS)
	echo Archiving $@...
	$(RM) $@
	$(LIBCOMMAND) $@ $(OBJS)
	$(RANLIB) $@

#
# Make dependencies...
#

depend: $(OBJS:.o=.c)
	makedepend -Y -I.. -f makedepend -w 20 $(OBJS:.o=.c)
	echo "# DO NOT DELETE THIS LINE -- make depend depends on it." > makedepend.tmp
	echo "" >> makedepend.tmp
	grep '^[a-zA-Z]' makedepend | ( LC_ALL=C sort -u -f >> makedepend.tmp; )
	mv makedepend.tmp makedepend

include makedepend

$(OBJS):	../makeinclude

=== src/xutf8/utils/Makefile ===
euc_tw: euc_tw.c
	gcc  euc_tw.c -o  euc_tw

all: convert_map create_table conv_gen
	./tbl_gen.sh
	./non_spacing.sh
	./case.sh

conv_gen: conv_gen.c
	gcc conv_gen.c -o conv_gen

convert_map: convert_map.c
	gcc convert_map.c -o convert_map

create_table: create_table.c
	gcc create_table.c -o create_table

clean:
	rm -f *.o convert_map create_table conv_gen euc_tw

=== debian/changelog ===
fltk1.4 (1.4.3-1ubuntu2) questing; urgency=medium

  * Back in sync with Debian, with new lto-disabled-list 58 adding it

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 06 May 2025 12:31:40 +0200

fltk1.4 (1.4.3-1) unstable; urgency=medium

  * Final 1.4.3 (and likely 1.4.x) release, with only formal changes
    relative to the last snapshot from Debian's perspective.
  * Upload to unstable.

 -- Aaron M. Ucko <ucko@debian.org>  Tue, 29 Apr 2025 21:00:37 -0400

fltk1.4 (1.4.3~20250423+82d5679f9cf1-2) experimental; urgency=medium

  * debian/libfltk1.4.symbols*: Go ahead with libfltk1.4.symbols.<arch>,
    with most of libfltk1.4.symbols' direct contents factored out into
    libfltk1.4.symbols.common.  Tagged inclusions mostly worked out, but
    lacked a good way to indicate that certain symbols should be present
    on 64-bit architectures and *-i386 (i.e., architectures on which
    time_t is simply long) but not anywhere else.  An additional benefit
    is being able to supply a generic fltk1.4.symbols that's open to any
    known va_list representation and to the possibility that Wayland
    support may or may not be present.
  * debian/libfltk1.4.symbols.{common,wayland}: Mark append/insertion
    vector symbols as Wayland-specific.
  * debian/rules: Drop unprefixed game manpages.  (Closes: #1104139.)
  * Standards-Version: 4.7.2 (routine-update)
  * Remove trailing whitespace in debian/changelog (routine-update)

 -- Aaron M. Ucko <ucko@debian.org>  Fri, 25 Apr 2025 18:17:31 -0400

fltk1.4 (1.4.3~20250423+82d5679f9cf1-1) experimental; urgency=medium

  * New upstream snapshot.
  * debian/control: Add xauth and xvfb to Build-Depends-Indep for xvfb-run.
  * debian/fltk1.4-doc.doc-base: Adjust description to note Fluid doc split.
  * debian/fltk1.4-doc.doc-base.fluid: New.
  * debian/libfltk(-gl)1.4.symbols(.[no-]wayland): Account for symbol
    differences when building without Wayland, i.e. on the Hurd.
    (Other non-Linux architectures would be in the same boat, but are off
    the radar.)
  * debian/rules: Build and install Fluid's HTML and PDF documentation
    when covering architecture-independent packages; build them under
    xvfb-run to allow for screenshot inclusion.
  * fluid/documentation/CMakeLists.txt: Adjust detailed Fluid
    documentation's installation location; install it as part of
    fltk1.4-doc for now.  (It'll get a dedicated package post-Trixie.)

 -- Aaron M. Ucko <ucko@debian.org>  Wed, 23 Apr 2025 22:13:06 -0400

fltk1.4 (1.4.3~20250421+8ac2a9956-2) experimental; urgency=medium

  * debian/control: Limit libdecor build-deps to Linux too.

 -- Aaron M. Ucko <ucko@debian.org>  Tue, 22 Apr 2025 22:55:10 -0400

fltk1.4 (1.4.3~20250421+8ac2a9956-1) experimental; urgency=medium

  * New upstream release, mostly featuring build system changes, largely
    superseding the active parts of Debian's patch (which still formally
    retains changes to the traditional build system).
  * debian/control:
    - Build-depend on fluid (>= 1.4) when cross-compiling. (Closes: #1103807.)
    - Limit Wayland build dependencies to Linux per their availability.
    - libfltk1.4-dev: Stop suggesting libcairo2-dev now that it's a full
      dependency.  (See #1102961.)
  * debian/copyright: Pull out LGPL-2+ with static linking exception.
  * debian/rules: Update for new release:
    - Stop setting LD_LIBRARY_PATH now that the build uses a version of
      the fluid tool that links statically against FLTK.
    - Install fully dynamically linked versions of tools.
    - Move games from debian/tmp/usr/bin rather than copying them directly
      from under obj-*.
    - Install glpuzzle.man as flpuzzle.6 with appropriate substitutions.
    - Adjust override_dh_auto_install-indep's logic to wipe out all of
      debian/tmp/usr/bin but run at all only in the absence of
      .../usr/bin/fluid.

 -- Aaron M. Ucko <ucko@debian.org>  Tue, 22 Apr 2025 22:10:52 -0400

=== debian/control ===
Source: fltk1.4
Maintainer: Aaron M. Ucko <ucko@debian.org>
Section: libs
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               fluid (>= 1.4) <cross>,
               libcairo2-dev,
               libgl-dev | libgl1-mesa-dev,
               libglu1-mesa-dev | libglu-dev,
               libjpeg-dev,
               libpng-dev,
               libx11-dev,
               libxcursor-dev,
               libxext-dev,
               libxft-dev,
               libxinerama-dev,
               pkgconf,
               zlib1g-dev | libz-dev
Build-Depends-Arch: libasound2-dev [linux-any],
                    libdbus-1-dev,
                    libegl-dev,
                    libdecor-0-dev (>= 0.2.0) [linux-any] | libgtk-3-dev [linux-any],
                    libdecor-0-plugin-1-gtk [linux-any],
                    libglew-dev,
                    libpango1.0-dev,
                    libwayland-dev [linux-any],
                    libxkbcommon-dev,
                    wayland-protocols [linux-any]
Build-Depends-Indep: doxygen-latex,
                     texlive-font-utils,
                     texlive-latex-extra,
                     xauth,
                     xvfb
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/ucko/fltk1.4
Vcs-Git: https://salsa.debian.org/ucko/fltk1.4.git
Homepage: https://www.fltk.org/
Rules-Requires-Root: no

Package: fluid
Architecture: any
Multi-Arch: foreign
Section: devel
Depends: ${misc:Depends},
         ${shlibs:Depends}
Recommends: fltk1.4-doc,
            libfltk1.4-dev
Description: Fast Light Toolkit - user interface designer
 This package provides Fluid, an interactive GUI designer for FLTK,
 allowing graphical development of FLTK-based user
 interfaces. It natively works with (textual) .fl files, but also
 includes rough support for reading .fd files produced by fdesign (in
 libforms-bin).
 .
 The Fast Light Toolkit (FLTK) is a cross-platform graphical user interface
 toolkit originally based on libForms.

Package: fltk-options
Architecture: any
Multi-Arch: foreign
Section: x11
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Fast Light Toolkit - library option manager
 This package provides a tool for viewing and setting overall FLTK options
 interactively or programmatically.
 .
 The Fast Light Toolkit (FLTK) is a cross-platform graphical user interface
 toolkit originally based on libForms.

Package: libfltk1.4-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: dpkg-dev,
         libcairo2-dev,
         libfltk-cairo1.4 (= ${binary:Version}),
         libfltk-forms1.4 (= ${binary:Version}),
         libfltk-gl1.4 (= ${binary:Version}),
         libfltk-images1.4 (= ${binary:Version}),
         libfltk1.4 (= ${binary:Version}),
         libx11-dev,
         ${misc:Depends}
Recommends: fluid,
            libgl-dev,
            libglu1-mesa-dev | libglu-dev
Suggests: fltk1.4-doc,
          libjpeg-dev,
          libpng-dev,
          libxext-dev,
          libxft-dev,
          libxinerama-dev,
          zlib1g-dev | libz-dev
Conflicts: libfltk-dev
Provides: libfltk-dev
Replaces: libfltk-dev
Description: Fast Light Toolkit - development files
 This package provides the files necessary for compiling programs
 that depend on FLTK.
 .
 The Fast Light Toolkit (FLTK) is a cross-platform graphical user interface
 toolkit originally based on libForms.

Package: libfltk1.4-compat-headers
Architecture: all
Multi-Arch: foreign
Section: libdevel
Depends: libfltk1.4-dev,
         ${misc:Depends}
Conflicts: libfltk1.3-compat-headers, libfltk-compat-headers
Provides: libfltk1.3-compat-headers, libfltk-compat-headers
Replaces: libfltk1.3-compat-headers, libfltk-compat-headers
Description: Fast Light Toolkit - compatibility header symlinks
 This package provides header symlinks with .h rather than .H extensions for
 compatibility with some older code that relies on the lowercase-h names.

Package: libfltk1.4
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Suggests: fltk-options
Description: Fast Light Toolkit - main shared library
 This package contains the files necessary for running programs
 dynamically linked with FLTK.
 .
 The Fast Light Toolkit (FLTK) is a cross-platform graphical user interface
 toolkit originally based on libForms.

Package: libfltk-cairo1.4
Architecture: any
Multi-Arch: same
Depends: libfltk1.4 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Fast Light Toolkit - Cairo rendering layer support
 This package contains the files necessary for running programs
 dynamically linked with FLTK's Cairo rendering layer bindings.
 .
 The Fast Light Toolkit (FLTK) is a cross-platform graphical user interface
 toolkit originally based on libForms.

Package: libfltk-forms1.4
Architecture: any
Multi-Arch: same
Depends: libfltk1.4 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Fast Light Toolkit - Forms compatibility layer support
 This package contains the files necessary for running programs
 dynamically linked with FLTK's Forms compatibility layer.
 .
 The Fast Light Toolkit (FLTK) is a cross-platform graphical user interface
 toolkit originally based on libForms.

Package: libfltk-gl1.4
Architecture: any
Multi-Arch: same
Depends: libfltk1.4 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Fast Light Toolkit - OpenGL rendering support
 This package contains the files necessary for running programs
 dynamically linked with FLTK's OpenGL rendering bindings.
 .
 The Fast Light Toolkit (FLTK) is a cross-platform graphical user interface
 toolkit originally based on libForms.

Package: libfltk-images1.4
Architecture: any
Multi-Arch: same
Depends: libfltk1.4 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Fast Light Toolkit - image loading support
 This package contains the files necessary for running programs
 dynamically linked with FLTK's bindings to image-loading libraries.
 .
 The Fast Light Toolkit (FLTK) is a cross-platform graphical user interface
 toolkit originally based on libForms.

Package: fltk1.4-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Description: Fast Light Toolkit - documentation
 This package provides documentation for FLTK, including a chapter on
 its user interface designer (fluid).
 .
 The Fast Light Toolkit (FLTK) is a cross-platform graphical user interface
 toolkit originally based on libForms.

Package: fltk1.4-games
Architecture: any
Multi-Arch: foreign
Section: games
Depends: ${misc:Depends},
         ${shlibs:Depends}
Recommends: ${shlibs:Recommends}
Conflicts: fltk1.1-games, fltk1.3-games
Replaces: fltk1.1-games, fltk1.3-games
Description: Fast Light Toolkit - example games: checkers, sudoku
 This package contains the example games that accompany FLTK.
 Specifically, it contains the following two programs:
  - flblocks:   clear groups of adjacent blocks before they fill the screen;
  - flcheckers: classic board game, also known as draughts;
  - flpuzzle:   Klotski puzzle (slide blocks around);
  - flsudoku:   Sudoku puzzle (place numbers in a grid).
 .
 NB: flpuzzle has a heavier dependency chain than the other games; playing
 it requires having this package's recommendations installed.
 .
 The Fast Light Toolkit (FLTK) is a cross-platform graphical user interface
 toolkit originally based on libForms.

=== debian/rules ===
#!/usr/bin/make -f
XCFLAGS = -Wall -Wunused -Wno-format-y2k -fPIE -fno-strict-aliasing -DCP936 \
	  -fvisibility-inlines-hidden

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = $(XCFLAGS)
export DEB_CXXFLAGS_MAINT_APPEND = $(XCFLAGS)

DPKG_EXPORT_BUILDFLAGS = yes
include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildflags.mk

GAMES = blocks checkers sudoku

FLTK_CONFIG = $(DEB_HOST_GNU_TYPE)-fltk-config
PKG_CONFIG = /usr/bin/$(DEB_HOST_GNU_TYPE)-pkg-config
export PKG_CONFIG

cmake_out = obj-$(DEB_HOST_GNU_TYPE)

%:
	dh $@ --buildsystem=cmake

override_dh_autoreconf:;
override_dh_autoreconf_clean:;
override_dh_update_autotools_config:;

override_dh_clean:
	dh_clean
	chmod +x debian/fix-fltk-* debian/fltk-config

INDEP = FLUID_DOCS LINKS HTML_DOCS PDF_DOCS

override_dh_auto_configure:
	if dh_listpackages | grep -q doc; then \
	    install_indep="$(INDEP:%=-DFLTK_INSTALL_%:BOOL=ON)"; \
	    install_indep="$$install_indep -DFLTK_BUILD_FLUID_DOCS:BOOL=ON"; \
	else \
	    install_indep=; \
	fi; \
	dh_auto_configure -- \
            -DFLTK_OPTION_CAIRO_EXT:BOOL=ON -DFLTK_BUILD_SHARED_LIBS:BOOL=ON \
	    $$install_indep -DCMAKE_SKIP_RPATH:BOOL=ON \
            -DCMAKE_HAVE_THREADS_LIBRARY:BOOL=ON -DFLTK_OPTION_STD:BOOL=ON
	find $(cmake_out)/CMakeFiles/Export -name FLTK-Targets.cmake \
	    -exec debian/fix-fltk-targets debian/FLTK-Targets-head.cmake \
	    {} \; > $(cmake_out)/etc/FLTK-Targets.cmake
	find $(cmake_out)/CMakeFiles/Export -name FLTK-Targets-none.cmake \
	    -exec debian/fix-fltk-targets {} \
	    debian/FLTK-Targets-none-tail.cmake \; \
	    > $(cmake_out)/etc/FLTK-Targets-none.cmake
	sed -e '/^endif/q' $(cmake_out)/FLTKConfigVersion.cmake \
	    > $(cmake_out)/etc/FLTKConfigVersion.cmake
	grep '^add_' $(cmake_out)/etc/FLTK-Targets.cmake
	grep 'check_targets' $(cmake_out)/etc/FLTK-Targets-none.cmake

override_dh_auto_build-indep:
	dh_auto_build -i
	xvfb-run -a $(MAKE) -C $(cmake_out) docs fluid_pdf

override_dh_auto_install-arch:
	dh_auto_install -a
	for x in debian/tmp/usr/bin/*-shared; do \
	    mv -fv $$x $${x%-shared}; \
	done
	mkdir -p debian/tmp/usr/games
	mkdir -p debian/tmp/usr/share/applications
	mkdir -p debian/tmp/usr/share/icons/hicolor/32x32/apps
	mkdir -p debian/tmp/usr/share/icons/hicolor/128x128/apps
	mkdir -p debian/tmp/usr/share/man/man6
	mkdir -p debian/tmp/usr/share/pixmaps
## fltk1.4-games (installed by hand to be able to add fl prefixes.)
	for game in $(GAMES); do \
	    mv -fv debian/tmp/usr/bin/$$game debian/tmp/usr/games/fl$$game && \
	    sed -e 's,Exec=,&/usr/games/fl,; s,Icon=,&fl,; s,Name=,&FLTK ,' \
	      test/desktop/$$game.desktop \
	      >debian/tmp/usr/share/applications/fl$$game.desktop && \
	    cp test/desktop/$$game-32.png \
	      debian/tmp/usr/share/icons/hicolor/32x32/apps/fl$$game.png && \
	    cp test/desktop/$$game-128.png \
	      debian/tmp/usr/share/icons/hicolor/128x128/apps/fl$$game.png && \
	    sed -e '1s,^\.TH ,&fl,; 3s,^,fl,' documentation/src/$$game.man \
	      >debian/tmp/usr/share/man/man6/fl$$game.6 \
	    || exit 1; \
	done
	mv debian/tmp/usr/bin/glpuzzle debian/tmp/usr/games/flpuzzle
	sed -e '1s,^\(\.TH \)gl,\1fl,; 3s,^gl,fl,; s/fIglpuzzle/fIflpuzzle/g' \
	  documentation/src/glpuzzle.man \
	  >debian/tmp/usr/share/man/man6/flpuzzle.6
	rm -fv debian/tmp/usr/share/man/man6/[!f]*.6
	cp -fv $(cmake_out)/etc/*.cmake debian/tmp/usr/share/fltk/
	debian/fix-fltk-config $(cmake_out)/fltk-config \
	    > debian/tmp/usr/bin/$(FLTK_CONFIG)
	chmod 755 debian/tmp/usr/bin/$(FLTK_CONFIG)
	rm -f debian/tmp/usr/bin/fltk-config

override_dh_auto_install-indep:
	if [ ! -f debian/tmp/usr/bin/fluid ]; then \
	    dh_auto_install -i && \
	    rm -fv debian/tmp/usr/bin/* ; \
	fi

override_dh_installdocs:
	dh_installdocs -A CREDITS.txt README.txt

override_dh_installchangelogs:
	dh_installchangelogs CHANGES.txt
	for x in debian/*/usr/share/doc/*/changelog; do \
	    mv -v $$x `dirname $$x`/NEWS; \
	done

override_dh_installman-arch:
	dh_installman
	ln -snfv fltk-config.1 \
	    debian/libfltk1.4-dev/usr/share/man/man1/$(FLTK_CONFIG).1

override_dh_missing-arch:
	cd debian/tmp  &&  for x in usr/share/man/*/*; do \
	    if [ -f ../*/$$x.gz ]; then rm -f $$x; fi \
	done
	dh_missing -Xusr/include/Fl

override_dh_missing-indep:
	dh_missing -Xusr/include/Fl -Xusr/share/man

override_dh_shlibdeps-arch:
	dh_shlibdeps -Nfltk1.4-games
	dh_shlibdeps -pfltk1.4-games -Xflpuzzle -- -dRecommends \
	    debian/fltk1.4-games/usr/games/flpuzzle -dDepends
